#!/usr/bin/perl

use warnings;
use strict;

use File::Spec;
use Cwd;
use IO::Compress::Gzip qw(gzip $GzipError);

my ( undef, $scriptdir, undef ) = File::Spec->splitpath(__FILE__);
my $htmldir = Cwd::abs_path(
    File::Spec->catdir( $scriptdir, File::Spec->updir(), 'html' ) );
my $includedir = Cwd::abs_path(
    File::Spec->catdir( $scriptdir, File::Spec->updir(), 'include' ) );

# Interate all arguments
foreach my $filein (@ARGV) {

    my (undef, undef, $fileinbase) = File::Spec->splitpath($filein);
    my $fileout = $fileinbase;

    $fileout =~ s/\./_/g;
    $fileout = $fileout . '_gz.h';

    #$filein  = File::Spec->catfile( $htmldir,    $filein );
    $fileout = File::Spec->catfile( $includedir, $fileout );

    undef $/;    # Slurp mode

    print "Processing [$filein] to [$fileout]\n";

    die "usage: make_index.pl InputFile OutputFile"
      unless ( defined $filein && defined $fileout );
    die "File 1 does not exist" unless -r $filein;

    open( OUTF, ">", $fileout ) or die "Cannot open $fileout for writing: $!";

    my $constbase = $fileinbase;
    $constbase =~ s/\./_/g;

    my $data = "";
    gzip $filein => \$data,
      -Level     => 9
      or die "gzip failed: $GzipError\n";

    my $datalen = length($data);

    my $c = 0;    # Byte counter

    print OUTF "// Autogenerated from $filein file input\n";
    print OUTF "\n";
    printf OUTF "#define %s_gz_len %d\n", $constbase, $datalen;
    printf OUTF "const uint8_t %s_gz[] = {\n\t", $constbase;

    # Print out hex bytes
    while ( $c < $datalen ) {
        my $byte = substr( $data, $c, 1 );
        printf OUTF "0x%02x", ord($byte);
        $c++;
        printf OUTF "," unless $c == $datalen;
        printf OUTF "\n\t" if ( $c % 16 == 0 );
    }
    printf OUTF "\n};";
    close OUTF;
}